---
title: Form表单
---

Form表单

### 引入

```javascript
import { Form } from '@jd/jdc-vue-toolkit'

Vue.component(Form.name, Form)
```

### 代码演示
<!-- DEMO -->

### API

#### Attributes
|属性 | 说明 | 类型 | 默认值| 备注|
|----|-----|------|------|------|
|labelWidth|表单域标签的宽度，作为 Form 直接子元素的form-item 会继承该值|String|-|-|
|formData|form表单的值|Object|-|-|
|formProps|form表单的属性|Object|-|详情见[Form Attributes](https://element.eleme.io/#/zh-CN/component/form)|
|items|渲染form-item的属性组成的数组|Array|-|**label**:&nbsp;&nbsp;标签文本;</br> **name**:&nbsp;&nbsp;表单域 model 字段，在使用 validate、resetFields 方法的情况下，该属性是必填的;</br> **formItemProps**:&nbsp;&nbsp;详情见[Form-Item Attributes](https://element.eleme.io/#/zh-CN/component/form);</br> **type**:&nbsp;&nbsp;渲染类型，现有以下几种：input，radio，radioButton，checkbox，date，number，colorPicker；</br> **methods**:&nbsp;&nbsp;各表单对应的方法; props:各表单对应的属性|

#### Methods

|方法名 | 说明 | 参数 |
|----|-----|------|
|validate|对整个表单进行校验的方法，返回一个promise|-|
|resetForm|对整个表单进行重置，将所有字段值重置为初始值并移除校验结果|-|
|clearValidate|移除整个表单的校验结果|-|
