;(function(){
(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'element-ui', '../_style/global.css', './style/index.css'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('element-ui'), require('../_style/global.css'), require('./style/index.css'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.elementUi, global.global, global.index);
    global.index = mod.exports;
  }
})(this, function (exports, _elementUi) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _components;

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  exports.default = {
    name: 'uc-form',
    components: (_components = {}, _defineProperty(_components, _elementUi.Form.name, _elementUi.Form), _defineProperty(_components, _elementUi.FormItem.name, _elementUi.FormItem), _defineProperty(_components, _elementUi.Input.name, _elementUi.Input), _defineProperty(_components, _elementUi.Radio.name, _elementUi.Radio), _defineProperty(_components, _elementUi.RadioButton.name, _elementUi.RadioButton), _defineProperty(_components, _elementUi.RadioGroup.name, _elementUi.RadioGroup), _defineProperty(_components, _elementUi.Checkbox.name, _elementUi.Checkbox), _defineProperty(_components, _elementUi.CheckboxGroup.name, _elementUi.CheckboxGroup), _defineProperty(_components, _elementUi.DatePicker.name, _elementUi.DatePicker), _defineProperty(_components, _elementUi.InputNumber.name, _elementUi.InputNumber), _defineProperty(_components, _elementUi.ColorPicker.name, _elementUi.ColorPicker), _defineProperty(_components, _elementUi.Select.name, _elementUi.Select), _defineProperty(_components, _elementUi.Option.name, _elementUi.Option), _components),
    props: {
      labelWidth: {
        type: String,
        default: '120px'
      },
      items: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      formData: {
        type: Object,
        default: function _default() {}
      },
      formProps: {
        type: Object,
        default: function _default() {}
      }
    },
    computed: {
      rules: function rules() {
        return this.items.reduce(function (map, item) {
          if (item.rules) {
            map[item.name] = item.rules;
          }
          return map;
        }, {});
      }
    },
    methods: {
      validate: function validate() {
        var _this = this;

        return new Promise(function (resolve, reject) {
          _this.$refs.form.validate(function (valid) {
            if (valid) {
              resolve();
            } else {
              reject();
            }
          });
        });
      },
      resetForm: function resetForm() {
        this.$refs.form.resetFields();
      },
      clearValidate: function clearValidate() {
        this.$refs.form.clearValidate();
      }
    }
  };
});
})()
if (module.exports.__esModule) module.exports = module.exports.default
var __vue__options__ = (typeof module.exports === "function"? module.exports.options: module.exports)
__vue__options__.render = function render () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('el-form',_vm._b({ref:"form",attrs:{"model":_vm.formData,"label-width":_vm.labelWidth,"rules":_vm.rules,"validate-on-rule-change":false}},'el-form',_vm.formProps,false),_vm._l((_vm.items),function(item,index){return _c('el-form-item',_vm._b({key:index,attrs:{"label":item.label,"prop":item.name,"label-width":_vm.labelWidth}},'el-form-item',item.formItemProps,false),[(item.type === 'input')?[_c('el-input',_vm._g(_vm._b({model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},'el-input',item.props,false),item.methods))]:_vm._e(),_vm._v(" "),(item.type === 'radio')?_vm._l((item.props.list),function(d,idx){return _c('el-radio',_vm._g(_vm._b({key:idx,attrs:{"label":d.label},model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},'el-radio',item.props,false),item.methods),[_vm._v("\n        "+_vm._s(d.value)+"\n      ")])}):_vm._e(),_vm._v(" "),(item.type === 'radioButton')?[_c('el-radio-group',{model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},_vm._l((item.props.list),function(d,idx){return _c('el-radio-button',_vm._g(_vm._b({key:idx,attrs:{"label":d.label},model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},'el-radio-button',item.props,false),item.methods),[_vm._v("\n        "+_vm._s(d.value)+"\n      ")])}),1)]:_vm._e(),_vm._v(" "),(item.type === 'checkbox')?[_c('el-checkbox-group',{model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},_vm._l((item.props.list),function(d,idx){return _c('el-checkbox',_vm._g(_vm._b({key:idx,attrs:{"label":d.label},model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},'el-checkbox',item.props,false),item.methods),[_vm._v("\n          "+_vm._s(d.label)+"\n        ")])}),1)]:_vm._e(),_vm._v(" "),(item.type === 'date')?[_c('el-date-picker',_vm._g(_vm._b({attrs:{"picker-options":item.pickerOptions},model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},'el-date-picker',item.props,false),item.methods))]:_vm._e(),_vm._v(" "),(item.type === 'number')?[_c('el-input-number',_vm._g(_vm._b({model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},'el-input-number',item.props,false),item.methods))]:_vm._e(),_vm._v(" "),(item.type === 'colorPicker')?[_c('el-color-picker',_vm._g(_vm._b({model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},'el-color-picker',item.props,false),item.methods))]:_vm._e(),_vm._v(" "),(item.type === 'select')?[_c('el-select',_vm._g(_vm._b({model:{value:(_vm.formData[item.name]),callback:function ($$v) {_vm.$set(_vm.formData, item.name, $$v)},expression:"formData[item.name]"}},'el-select',item.props,false),item.methods),_vm._l((item.props.list),function(i,idx){return _c('el-option',{key:idx,attrs:{"label":i.label,"value":i.value}})}),1)]:_vm._e(),_vm._v(" "),(item.type === 'slot')?_vm._t(item.slotName):_vm._e()],2)}),1)}
__vue__options__.staticRenderFns = []
