---
title: Table列表组件
---

Table列表

### 引入

```javascript
import { Table } from '@jd/jdc-vue-toolkit'

Vue.component(Table.name, Table)
```

### 代码演示
<!-- DEMO -->

### API

#### Attributes
|属性 | 说明 | 类型 | 默认值| 备注|
|----|-----|------|------|------|
|tableProps|[Table Attributes](https://element.eleme.cn/2.0/#/zh-CN/component/table)|Object|-|table属性|
|tableEvents|[Table Events](https://element.eleme.cn/2.0/#/zh-CN/component/table)|Object|-|table events|
|columns|table-item属性，其中 prop：对应列内容的字段名，也可以使用 property 属性；label：显示的标题； props：其他属性：[Table-column Attributes](https://element.eleme.cn/2.0/#/zh-CN/component/table) |Array|-| - |
|selectionColumnWidth|选择框的宽度|Number|55||
|options|根据不同状态展示不同操作，其中 label: 操作名称；showConfig：显示条件；onClick： 操作方法|Array|-|-|
|data|显示的数据|Array|-|-|
|hasPagination|是否需要分页|Boolean|true|从1.0.13版本起，此属性作废，请用pagingType属性代替|
|pagingType|分页类型: 前端/后端/不分页|String|back|front/back/none|
|paginationOption|[pagination Attributes](https://element.eleme.io/#/zh-CN/component/pagination#attributes)|Object|pageSizes默认值[10, 20, 30, 50];layout: 'prev,pager,next,sizes,jumper,->'||
|fetch|初始化数据的方法|Function|-|其中该方法参数params为{currentPage , pageSize}|

#### Methods
|方法名 | 说明 | 参数 |
|----|-----|------|
|clearSelection|用于多选表格，清空用户的选择，当使用 reserve-selection 功能的时候，可能会需要使用此方法|selection|
|toggleRowSelection|用于多选表格，切换某一行的选中状态，如果使用了第二个参数，则是设置这一行选中与否（selected 为 true 则选中）|row, selected|
|toggleRowExpansion|用于可展开表格，切换某一行的展开状态，如果使用了第二个参数，则是设置这一行展开与否（expanded 为 true 则展开）|row, expanded|
|setCurrentRow|用于可展开表格，切换某一行的展开状态，如果使用了第二个参数，则是设置这一行展开与否（expanded 为 true 则展开）|row|
|clearSort|用于清空排序条件，数据会恢复成未排序的状态|-|
|clearFilter|用于清空过滤条件，数据会恢复成未过滤的状态|-|
|doLayout|对 Table 进行重新布局。当 Table 或其祖先元素由隐藏切换为显示时，可能需要调用此方法|-|
|refreshData|刷新table数据。当执行table查询等功能时，可能需要调用此方法|-|
