;(function(){
(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'element-ui', './scroll-to.js', '../_style/global.css', './style/pagination.css'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('element-ui'), require('./scroll-to.js'), require('../_style/global.css'), require('./style/pagination.css'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.elementUi, global.scrollTo, global.global, global.pagination);
    global.pagination = mod.exports;
  }
})(this, function (exports, _elementUi, _scrollTo) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  exports.default = {
    inheritAttrs: false,
    name: 'Pagination',
    components: _defineProperty({}, _elementUi.Pagination.name, _elementUi.Pagination),
    props: {
      page: {
        type: Number,
        default: 1
      },
      limit: {
        type: Number,
        default: 20
      },
      pageSizes: {
        type: Array,
        default: function _default() {
          return [10, 20, 30, 50];
        }
      },
      background: {
        type: Boolean,
        default: true
      },
      autoScroll: {
        type: Boolean,
        default: true
      },
      hidden: {
        type: Boolean,
        default: false
      }
    },
    computed: {
      currentPage: {
        get: function get() {
          return this.page;
        },
        set: function set(val) {
          sessionStorage.setItem('page', val);
          this.$emit('update:page', val);
        }
      },
      pageSize: {
        get: function get() {
          return this.limit;
        },
        set: function set(val) {
          this.$emit('update:limit', val);
        }
      }
    },
    methods: {
      handleSizeChange: function handleSizeChange(val) {
        this.$emit('pagination', { page: this.currentPage, limit: val });
        if (this.autoScroll) {
          (0, _scrollTo.scrollTo)(0, 800);
        }
      },
      handleCurrentChange: function handleCurrentChange(val) {
        this.$emit('pagination', { page: val, limit: this.pageSize });
        if (this.autoScroll) {
          (0, _scrollTo.scrollTo)(0, 800);
        }
      }
    }
  };
});
})()
if (module.exports.__esModule) module.exports = module.exports.default
var __vue__options__ = (typeof module.exports === "function"? module.exports.options: module.exports)
__vue__options__.render = function render () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"pagination-container",class:{'hidden':_vm.hidden}},[_c('el-pagination',_vm._b({attrs:{"background":_vm.background,"current-page":_vm.currentPage,"page-size":_vm.pageSize,"page-sizes":_vm.pageSizes},on:{"update:currentPage":function($event){_vm.currentPage=$event},"update:current-page":function($event){_vm.currentPage=$event},"update:pageSize":function($event){_vm.pageSize=$event},"update:page-size":function($event){_vm.pageSize=$event},"size-change":_vm.handleSizeChange,"current-change":_vm.handleCurrentChange}},'el-pagination',_vm.$attrs,false))],1)}
__vue__options__.staticRenderFns = []
__vue__options__._scopeId = "data-v-28d82cd3"
