;(function(){
(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'element-ui', '../_style/global.css', './style/index.css'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('element-ui'), require('../_style/global.css'), require('./style/index.css'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.elementUi, global.global, global.index);
    global.index = mod.exports;
  }
})(this, function (exports, _elementUi) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  exports.default = {
    name: 'uc-time-button',
    components: _defineProperty({}, _elementUi.Button.name, _elementUi.Button),
    props: {
      options: {
        type: Object,
        default: function _default() {
          return {
            type: 'text'
          };
        }
      },
      second: {
        type: Number,
        default: 60
      },
      disabled: {
        type: Boolean,
        default: false
      },
      normalText: {
        type: String,
        default: '发送邮箱验证码'
      },
      activeText: {
        type: String,
        default: '{$1}s后重新发送'
      }
    },
    data: function data() {
      return {
        time: 0
      };
    },

    computed: {
      text: function text() {
        return this.time > 0 ? '' + this.activeText.replace('{$1}', this.time) : '' + this.normalText;
      }
    },
    methods: {
      _onButtonClick: function _onButtonClick() {
        this.start();
        this.$emit('run');
      },
      start: function start() {
        this.time = this.second;
        this._timer();
      },
      stop: function stop() {
        this.time = 0;
        this.disabled = false;
      },
      setDisabled: function setDisabled(val) {
        this.disabled = val;
      },
      _timer: function _timer() {
        var time = this.time;

        if (time > 0) {
          this.time = time - 1;
          setTimeout(this._timer, 1000);
        } else {
          this.disabled = false;
        }
      }
    }
  };
});
})()
if (module.exports.__esModule) module.exports = module.exports.default
var __vue__options__ = (typeof module.exports === "function"? module.exports.options: module.exports)
__vue__options__.render = function render () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"uc-time-button"},[_c('el-button',_vm._b({attrs:{"disabled":_vm.disabled || _vm.time > 0},on:{"click":_vm._onButtonClick}},'el-button',_vm.options,false),[_vm._v("\n  "+_vm._s(_vm.text)+"\n  ")])],1)}
__vue__options__.staticRenderFns = []
