;(function(){
(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'element-ui', '../_style/global.css', './style/index.css'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('element-ui'), require('../_style/global.css'), require('./style/index.css'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.elementUi, global.global, global.index);
    global.index = mod.exports;
  }
})(this, function (exports, _elementUi) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  exports.default = {
    name: 'uc-upload',
    components: _defineProperty({}, _elementUi.Upload.name, _elementUi.Upload),
    props: {
      width: {
        deafult: '',
        type: String
      },
      height: {
        deafult: '',
        type: String
      },
      imageUrl: {
        deafult: '',
        type: String
      },

      uploading: {
        deafult: false,
        type: Boolean
      },
      imgSize: {
        deafult: 3,
        type: Number
      },
      props: {
        type: Object,
        default: function _default() {}
      },
      methods: {
        type: Object,
        default: function _default() {}
      }
    },
    computed: {
      imageStyle: function imageStyle() {
        var width = this.width,
            height = this.height;

        if (!width || !height) {
          return false;
        }
        var w = Number(width.split('px')[0]).toFixed(0);
        var h = Number(height.split('px')[0]).toFixed(0);
        if (w <= 100 || h <= 100) {
          return { width: w * 2 + 'px', height: h * 2 + 'px' };
        }

        if (w >= 720 || h >= 500) {
          return { width: w / 2 + 'px', height: h / 2 + 'px' };
        }
        return { width: w + 'px', height: h + 'px' };
      }
    },
    methods: {
      beforeUpload: function beforeUpload(file) {
        var _imgSize = this.imgSize,
            imgSize = _imgSize === undefined ? 3 : _imgSize;

        var typeArr = ['image/jpg', 'image/jpeg', 'image/png'];
        var result = typeArr.filter(function (i) {
          return file.type === i;
        });
        var isJPGPNG = result.includes(file.type);
        if (!isJPGPNG) {
          this.$message.error('上传头像图片只能是 JPG或PNG格式!');
          return false;
        }
        var isMaxM = file.size / 1024 / 1024 < imgSize;
        var errText = imgSize >= 1 ? '\u8BC1\u4EF6\u5927\u5C0F\u4E0D\u80FD\u8D85\u8FC7 ' + imgSize + 'MB!' : '\u8BC1\u4EF6\u5927\u5C0F\u4E0D\u80FD\u8D85\u8FC7 ' + imgSize * 1024 + 'KB!';
        if (!isMaxM) {
          this.$message.error(errText);
        }
        return isJPGPNG && isMaxM;
      },
      uploadFile: function uploadFile(file) {
        this.$emit('uploadFile', file.file);
      }
    }
  };
});
})()
if (module.exports.__esModule) module.exports = module.exports.default
var __vue__options__ = (typeof module.exports === "function"? module.exports.options: module.exports)
__vue__options__.render = function render () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"uc-upload"},[_c('el-upload',_vm._g(_vm._b({staticClass:"uc-upload__uploader",style:(_vm.imageStyle),attrs:{"action":"","show-file-list":false,"accept":".png, .jpg","before-upload":_vm.beforeUpload,"http-request":_vm.uploadFile}},'el-upload',_vm.props,false),_vm.methods),[(_vm.imageUrl)?_c('div',{style:(_vm.imageStyle)},[_c('div',{staticClass:"uc-upload__img-bg",style:(("background: url(" + _vm.imageUrl + ") no-repeat center"))})]):_vm._e(),_vm._v(" "),(!_vm.uploading)?[(!_vm.imageUrl)?_c('div',{staticClass:"uc-upload__upload-text"},[_c('div',[_c('i',{staticClass:"el-icon-plus uc-upload__uploader-icon"}),_vm._v(" "),_c('p',{staticClass:"uc-upload__text"},[_vm._v("上传照片")])])]):_c('div',{staticClass:"uc-upload__upload-mask"},[_c('div',[_c('i',{staticClass:"el-icon-plus uc-upload__uploader-icon"}),_vm._v(" "),_c('p',{staticClass:"uc-upload__text"},[_vm._v("上传照片")])])])]:[_c('div',{staticClass:"uc-upload__loading"},[_c('i',{staticClass:"el-icon-loading"})])]],2),_vm._v(" "),_c('div',{staticClass:"uc-upload__text-container"},[_c('p',{staticClass:"uc-upload__size-text"},[_vm._v("图片尺寸："+_vm._s((_vm.width + " * " + _vm.height)))]),_vm._v(" "),_c('p',{staticClass:"uc-upload__size-text"},[_vm._v("图片格式：jpg，png")])])],1)}
__vue__options__.staticRenderFns = []
__vue__options__._scopeId = "data-v-dfd011c8"
