---
title: SvgIcon 图标
---

SvgIcon 图标

### 引入

```javascript
import { SvgIcon } from '@jd/jdc-vue-toolkit'

Vue.component(SvgIcon.name, SvgIcon)
```
使用图标前需要引入svg图标资源，有两种方式：
#### iconfont图标引入

1、从https://www.iconfont.cn/ 下载设计好的图标资源文件

2、在项目中import './iconfont.js'
#### 自定义图标引入
此种情况适用于图标不存放到iconfont，需要自己导入。svg命名规则为:name.svg (name为组件属性)

1、配置svg文件加载loader
```js
chainWebpack(config) {
    ……
    // 去掉svg文件默认的loader对svg icon的处理,保证在其他目录中的svg文件还可以正常引入
    config.module
        .rule('svg')
        .exclude.add(resolve('src/svgs')) // svg 存放目录
        .end();
    
    config.module
        .rule('svg-icon') // rule的名字不能是svg
        .test(/\.svg$/)
        .include.add(resolve('src/svgs')) //svg 存放目录
        .end()
        .use('svg-sprite-loader')
        .loader('svg-sprite-loader')
        .options({
            symbolId: 'icon-[name]'
        })
        .end()
    ……
```

2、基于webpack打包的项目，可以在main.js通过如下代码导入
```
const req = require.context('./svg', false, /\.svg$/)
const requireAll = requireContext => requireContext.keys().map(requireContext)
requireAll(req)
```

### 代码演示
<!-- DEMO -->

### API

#### Icon Props
|属性 | 说明 | 类型 | 默认值| 备注|
|----|-----|------|------|------|
|name|图标名|String|-|必填|
|color|颜色|String|-|-|
|className|样式类名|String|-|-|
|size|大小|[Number, String]|12|number为px|

#### SvgIcon Events

##### @click(event)
点击事件