;(function(){
(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'babel-runtime/regenerator', 'element-ui', './pagination', '../_style/global.css', './style/index.css'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('babel-runtime/regenerator'), require('element-ui'), require('./pagination'), require('../_style/global.css'), require('./style/index.css'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.regenerator, global.elementUi, global.pagination, global.global, global.index);
    global.index = mod.exports;
  }
})(this, function (exports, _regenerator, _elementUi, _pagination) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _regenerator2 = _interopRequireDefault(_regenerator);

  var _pagination2 = _interopRequireDefault(_pagination);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _asyncToGenerator(fn) {
    return function () {
      var gen = fn.apply(this, arguments);
      return new Promise(function (resolve, reject) {
        function step(key, arg) {
          try {
            var info = gen[key](arg);
            var value = info.value;
          } catch (error) {
            reject(error);
            return;
          }

          if (info.done) {
            resolve(value);
          } else {
            return Promise.resolve(value).then(function (value) {
              step("next", value);
            }, function (err) {
              step("throw", err);
            });
          }
        }

        return step("next");
      });
    };
  }

  var _components;

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  exports.default = {
    name: 'uc-table',
    components: (_components = {}, _defineProperty(_components, _elementUi.Table.name, _elementUi.Table), _defineProperty(_components, _elementUi.TableColumn.name, _elementUi.TableColumn), _defineProperty(_components, _elementUi.Button.name, _elementUi.Button), _defineProperty(_components, _pagination2.default.name, _pagination2.default), _defineProperty(_components, _elementUi.Loading.name, _elementUi.Loading), _components),
    props: {
      tableProps: {
        type: Object,
        default: function _default() {}
      },
      tableEvents: {
        type: Object,
        default: function _default() {}
      },
      columns: { required: true, type: Array },
      selectionColumnWidth: {
        type: Number,
        default: 55
      },
      options: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      hasSelection: {
        type: Boolean,
        default: false
      },
      hasPagination: {
        type: Boolean,
        default: true
      },

      pagingType: {
        type: String,
        default: 'back'
      },
      pageSize: {
        type: Number,
        default: 10
      },
      paginationOption: {
        type: Object,
        default: function _default() {
          return {
            layout: 'prev,pager,next,sizes,jumper,->'
          };
        }
      },
      fetch: Function
    },
    data: function data() {
      return {
        list: [],
        loading: false,
        total: 0,
        currentPage: 1
      };
    },
    watch: {
      list: function list(newVal) {
        if (newVal && newVal.length > 0) {
          this.list = newVal;
        }
      }
    },
    created: function created() {
      var _list = this.list,
          list = _list === undefined ? [] : _list;

      if (list.length === 0) {
        this.loadList();
      }
    },

    methods: {
      loadList: function () {
        var _ref = _asyncToGenerator(_regenerator2.default.mark(function _callee() {
          var currentPage, pageSize, _ref2, list, total;

          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  currentPage = this.currentPage, pageSize = this.pageSize;

                  this.loading = true;
                  _context.next = 5;
                  return this.fetch({ currentPage: currentPage, pageSize: pageSize });

                case 5:
                  _ref2 = _context.sent;
                  list = _ref2.list;
                  total = _ref2.total;

                  this.list = list;
                  this.total = !this.hasPagination || this.pagingType === 'none' ? 0 : total;

                  if (!(this.pagingType === 'back')) {
                    _context.next = 18;
                    break;
                  }

                  if (!(list.length === 0)) {
                    _context.next = 18;
                    break;
                  }

                  if (!(currentPage === 1)) {
                    _context.next = 15;
                    break;
                  }

                  this.loading = false;
                  return _context.abrupt('return');

                case 15:
                  this.currentPage += -1;
                  if (this.currentPage <= 1) {
                    this.currentPage = 1;
                  }
                  this.loadList();

                case 18:
                  _context.next = 23;
                  break;

                case 20:
                  _context.prev = 20;
                  _context.t0 = _context['catch'](0);
                  console.log(_context.t0);

                case 23:
                  this.loading = false;

                case 24:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this, [[0, 20]]);
        }));

        function loadList() {
          return _ref.apply(this, arguments);
        }

        return loadList;
      }(),
      refreshData: function refreshData() {
        this.loadList();
      },
      clearSelection: function clearSelection() {
        this.$refs.table.clearSelection();
      },
      toggleRowSelection: function toggleRowSelection(row) {
        this.$refs.table.toggleRowSelection(row);
      },
      toggleRowExpansion: function toggleRowExpansion(row) {
        this.$refs.table.toggleRowExpansion(row);
      },
      setCurrentRow: function setCurrentRow(row) {
        this.$refs.table.setCurrentRow(row);
      },
      clearSort: function clearSort() {
        this.$refs.table.clearSort();
      },
      clearFilter: function clearFilter() {
        this.$refs.table.clearFilter();
      },
      doLayout: function doLayout() {
        this.$refs.table.doLayout();
      }
    }
  };
});
})()
if (module.exports.__esModule) module.exports = module.exports.default
var __vue__options__ = (typeof module.exports === "function"? module.exports.options: module.exports)
__vue__options__.render = function render () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_c('el-table',_vm._g(_vm._b({directives:[{name:"loading",rawName:"v-loading",value:(_vm.loading),expression:"loading"}],ref:"table",attrs:{"data":_vm.pagingType !== 'front' ? _vm.list : _vm.list.slice((_vm.currentPage - 1) * _vm.pageSize, _vm.currentPage * _vm.pageSize)}},'el-table',_vm.tableProps,false),_vm.tableEvents),[(_vm.hasSelection)?_c('el-table-column',{attrs:{"type":"selection","width":_vm.selectionColumnWidth}}):_vm._e(),_vm._v(" "),_vm._l((_vm.columns),function(item,idx){return _c('el-table-column',_vm._b({key:idx,attrs:{"prop":item.prop,"label":item.label,"className":item.prop},scopedSlots:_vm._u([{key:"default",fn:function(slotScope){return [(item.slot)?_vm._t(item.slot,null,null,slotScope):_vm._e(),_vm._v(" "),(!item.slot)?_c('span',[_vm._v("\n          "+_vm._s(item.formatter ? (item.formatter(slotScope.row) || '--') : (slotScope.row[item.prop] || '--'))+"\n        ")]):_vm._e()]}}],null,true)},'el-table-column',item.props,false))}),_vm._v(" "),(_vm.options.length)?_c('el-table-column',{attrs:{"label":"操作"},scopedSlots:_vm._u([{key:"default",fn:function(ref){
var row = ref.row;
return _vm._l((_vm.options),function(i,idx){return _c('el-button',{directives:[{name:"show",rawName:"v-show",value:(!Object.keys(i.showConfig).length || i.showConfig.rowValues.includes(row[i.showConfig.rowName])),expression:"!Object.keys(i.showConfig).length || i.showConfig.rowValues.includes(row[i.showConfig.rowName])"}],key:idx,attrs:{"type":"text"},on:{"click":function($event){return i.onClick(row)}}},[_vm._v("\n          "+_vm._s(i.label)+"\n        ")])})}}],null,false,3190363948)}):_vm._e()],2),_vm._v(" "),(_vm.hasPagination || _vm.pagingType === 'none')?_c('pagination',_vm._b({directives:[{name:"show",rawName:"v-show",value:(_vm.total>0),expression:"total>0"}],attrs:{"total":_vm.total,"page":_vm.currentPage,"limit":_vm.pageSize},on:{"update:page":function($event){_vm.currentPage=$event},"update:limit":function($event){_vm.pageSize=$event},"pagination":function($event){_vm.pagingType === 'back' ? _vm.loadList() : null}}},'pagination',_vm.paginationOption,false)):_vm._e()],1)}
__vue__options__.staticRenderFns = []
