;(function(){
(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'element-ui', '../_style/global.css', './style/EditorImage.css'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('element-ui'), require('../_style/global.css'), require('./style/EditorImage.css'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.elementUi, global.global, global.EditorImage);
    global.EditorImage = mod.exports;
  }
})(this, function (exports, _elementUi) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _components;

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  exports.default = {
    name: 'EditorSlideUpload',
    components: (_components = {}, _defineProperty(_components, _elementUi.Dialog.name, _elementUi.Dialog), _defineProperty(_components, _elementUi.Upload.name, _elementUi.Upload), _defineProperty(_components, _elementUi.Button.name, _elementUi.Button), _components),
    props: {
      color: {
        type: String,
        default: '#1890ff'
      },
      url: {
        type: String,
        default: 'https://httpbin.org/post'
      },
      fileUrlFormatter: {
        type: Function,
        required: false,
        default: function _default(data) {
          return data.files.file;
        }
      }

    },
    data: function data() {
      return {
        dialogVisible: false,
        listObj: {},
        fileList: []
      };
    },

    methods: {
      checkAllSuccess: function checkAllSuccess() {
        var _this = this;

        return Object.keys(this.listObj).every(function (item) {
          return _this.listObj[item].hasSuccess;
        });
      },
      handleSubmit: function handleSubmit() {
        var _this2 = this;

        var arr = Object.keys(this.listObj).map(function (v) {
          return _this2.listObj[v];
        });
        if (!this.checkAllSuccess()) {
          this.$message('Please wait for all images to be uploaded successfully. If there is a network problem, please refresh the page and upload again!');
          return;
        }
        this.$emit('successCBK', arr);
        this.listObj = {};
        this.fileList = [];
        this.dialogVisible = false;
      },
      handleSuccess: function handleSuccess(response, file) {
        var fileUrlFormatter = this.fileUrlFormatter;

        var uid = file.uid;
        var objKeyArr = Object.keys(this.listObj);
        for (var i = 0, len = objKeyArr.length; i < len; i++) {
          if (this.listObj[objKeyArr[i]].uid === uid) {
            this.listObj[objKeyArr[i]].url = fileUrlFormatter(response);
            this.listObj[objKeyArr[i]].hasSuccess = true;
            return;
          }
        }
      },
      handleRemove: function handleRemove(file) {
        var uid = file.uid;
        var objKeyArr = Object.keys(this.listObj);
        for (var i = 0, len = objKeyArr.length; i < len; i++) {
          if (this.listObj[objKeyArr[i]].uid === uid) {
            delete this.listObj[objKeyArr[i]];
            return;
          }
        }
      },
      beforeUpload: function beforeUpload(file) {
        var _self = this;
        var _URL = window.URL || window.webkitURL;
        var fileName = file.uid;
        this.listObj[fileName] = {};
        return new Promise(function (resolve) {
          var img = new Image();
          img.src = _URL.createObjectURL(file);
          img.onload = function () {
            _self.listObj[fileName] = { hasSuccess: false, uid: file.uid, width: this.width, height: this.height };
          };
          resolve(true);
        });
      }
    }
  };
});
})()
if (module.exports.__esModule) module.exports = module.exports.default
var __vue__options__ = (typeof module.exports === "function"? module.exports.options: module.exports)
__vue__options__.render = function render () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"upload-container"},[_c('el-button',{style:({background:_vm.color,borderColor:_vm.color}),attrs:{"icon":"el-icon-upload","size":"mini","type":"primary"},on:{"click":function($event){_vm.dialogVisible=true}}},[_vm._v("\n    文件上传\n  ")]),_vm._v(" "),_c('el-dialog',{attrs:{"append-to-body":true,"visible":_vm.dialogVisible},on:{"update:visible":function($event){_vm.dialogVisible=$event}}},[_c('el-upload',{staticClass:"editor-slide-upload",attrs:{"multiple":true,"file-list":_vm.fileList,"show-file-list":true,"on-remove":_vm.handleRemove,"on-success":_vm.handleSuccess,"before-upload":_vm.beforeUpload,"action":_vm.url,"list-type":"picture-card"}},[_c('el-button',{attrs:{"size":"small","type":"primary"}},[_vm._v("\n        点击上传\n      ")])],1),_vm._v(" "),_c('el-button',{attrs:{"size":"small"},on:{"click":function($event){_vm.dialogVisible = false}}},[_vm._v("\n      取消\n    ")]),_vm._v(" "),_c('el-button',{attrs:{"size":"small","type":"primary"},on:{"click":_vm.handleSubmit}},[_vm._v("\n      确认\n    ")])],1)],1)}
__vue__options__.staticRenderFns = []
__vue__options__._scopeId = "data-v-76681eb4"
