---
title: Tinymce 富文本编辑器
---

Tinymce 富文本编辑器

### 引入

```javascript
import { Tinymce } from '@jd/jdc-vue-toolkit'

Vue.component(Tinymce.name, Tinymce)
```

### 代码演示
<!-- DEMO -->

### API

#### v-model
可以通过v-model指令双向绑定
```
<uc-tinymce v-model="content"></uc-tinymce>
```

#### Attributes
|属性 | 说明 | 类型 | 默认值| 备注|
|----|-----|------|------|------|
|id|编辑器id|String|自动生成uuid|可以通过tinymce.get('ID')调用tinymce所有方法，[tinymce中文文档](http://tinymce.ax-z.cn/general/basic-setup.php)|
|toolbar|配置工具栏内容|Array|['searchreplace bold italic underline strikethrough alignleft aligncenter alignright outdent indent  blockquote undo redo removeformat subscript superscript code codesample', 'hr bullist numlist link image charmap preview anchor pagebreak insertdatetime media table emoticons forecolor backcolor fullscreen']|-|
|menubar|菜单上放置的项目|String|'file edit insert view format table'|-|
|customToolbar|是否自定义工具栏|Boolean|false|当为true时 slot customToolbar才生效|
|height|高度|String/Number|360|-|
|width|宽度|String/Number|auto|-|
|fileType|文件上传类型|String|base64|base64 / url|
|fileUploadUrl|文件上传服务端地址|String|https://httpbin.org/post|当fileType为url时有效|
|fileUrlFormatter|url格式化函数，返回文件url|Function|(data)=> data.files.file|每个服务返回格式不一样，通过此函数返回文件存储url|

#### Methods
|方法名 | 说明 | 参数 |
|----|-----|------|
|setContent|设置富文本编辑器内容|value|
|getContent|获取富文本编辑器内容|------|

#### slot
|名称 | 说明 |
|----|-----|
|customToolbar|自定义工具栏内容（工具栏右上角）|
